#include "CToast.h"

enum {AT_TopScores, AT_Instructions, AT_Beastiary, AT_Credits, AT_Motto, AT_NbrAttractModes};

#define NbrDemoSprites		9
#define TeaSprite			(NbrDemoSprites-1)
#define DescLeading			50

long	attractDisplayTicks[AT_NbrAttractModes] = {100,100,300,100, 100};

static	char	demoSprites[] = {ST_Wheel, ST_Aster, ST_Teacup,
						ST_Saucer, ST_CoffeePot, ST_Croissant, ST_Cube, ST_Cranny, ST_Teapot};

static 	StringPtr promptStr1 = "\pHit P to Play";
static 	StringPtr promptStr2 = "\p0-7 to change volume";
static 	StringPtr promptStr3 = "\pK to redefine keys";
static	StringPtr bullshit1 = "\pInsert Toast Beastiary Here";

static	StringPtr motto1 = "\pNeither cheese nor toast";
static	StringPtr motto2 = "\pwill keep this little teapot";
static	StringPtr motto3 = "\pfrom its appointed rounds.";

static	StringPtr credit1 = "\pProgram, Graphics and Sound";
static	StringPtr credit2 = "\pCopyright (c) 1995 Jim Bumgardner";
static	StringPtr credit3 = "\pAll Rights Reserved";

short	descTop=20;

StringPtr	spriteDesc[NbrDemoSprites][2] = {
	"\pCaffeine Molecule",				"\p  100 pts",
	
	"\pAsterisks",						"\p  100 pts",
	
	"\pCup",							"\p  100 pts",
	
	"\pSaucer",							"\p  500 pts",
	
	"\pPercolator",						"\p  600 pts",
	
	"\pExploding Croissant",			"\p  600 pts",
	
	"\pSwelling Itching Sugar Cube",	"\p  750 pts",
	
	"\pNook & Cranny",					"\p  750 pts",
	
	"\pThe Holy Teapot",				"\p"};
	
void DisplayAttractMode()
{
	CGrafPtr	curPort;
	GDHandle	curDevice;
	RGBColor	sc,fc;
	GetGWorld(&curPort,&curDevice);

	SetGWorld(gOffScreen,NULL);
	PaintRect(&gOffScreen->portRect);

	// DisplayPicture(BackgroundPICT,-1,-1);
	// FlickerStars();

	if (g12InchMode)
		DisplayPicture(SmallLogoPICT,42,42);
	else
		DisplayPicture(SmallLogoPICT,64,64);

	GetForeColor(&sc);

	switch (gAttractMode) {
	case AT_TopScores:
		DisplayTopScores();
		break;
	case AT_Instructions:
		TextFont(times);
		TextSize(12);
		TextFace(bold);
		TextMode(srcOr);
		fc.red = fc.green = fc.blue = 0xFFFF;
		RGBForeColor(&fc);
		
		CenterString(promptStr1);	Move(0,g12InchMode? -16 : -32);
		DrawString(promptStr1);

		CenterString(promptStr2);	Move(0,0);
		DrawString(promptStr2);

		CenterString(promptStr3);	Move(0,g12InchMode? 16 : 32);
		DrawString(promptStr3);

		TextMode(srcCopy);
		break;
	case AT_Beastiary:
		{
			short			i;
			SpriteInstance	*sp;

			TextFont(times);
			TextSize(12);
			TextFace(bold);
			TextMode(srcOr);
	
			for (i = 0,sp = sTable; i < NbrDemoSprites-1; ++i,++sp)
			{
				fc.red = fc.green = fc.blue = 0xCCCC;
				RGBForeColor(&fc);
				MoveTo(gCenterP.h,descTop+14+i*DescLeading);
				DrawString(spriteDesc[i][0]);
				fc.red = fc.green = fc.blue = 0x8888;
				RGBForeColor(&fc);
				MoveTo(gCenterP.h,descTop+26+i*DescLeading);
				DrawString(spriteDesc[i][1]);
				(*sDef[sp->type].drawFunc)(sp);
			}
			TextMode(srcCopy);
		}
		break;
	case AT_Credits:
		TextFont(times);
		TextSize(12);
		TextFace(bold);
		TextMode(srcOr);
		fc.red = fc.green = fc.blue = 0xAAAA;
		fc.red = 0x4444;
		RGBForeColor(&fc);
		
		CenterString(credit1);	Move(0,g12InchMode? -16 : -32);
		DrawString(credit1);

		CenterString(credit2);	Move(0,0);
		DrawString(credit2);

		CenterString(credit3);	Move(0,g12InchMode? 16 : 32);
		DrawString(credit3);

		TextMode(srcCopy);
		break;
	case AT_Motto:
		TextFont(times);
		TextSize(12);
		TextFace(bold);
		TextMode(srcOr);
		fc.red = fc.green = fc.blue = 0xAAAA;
		RGBForeColor(&fc);

		CenterString(motto1);	Move(0,g12InchMode? -16 : -32);
		DrawString(motto1);

		CenterString(motto2);	Move(0,0);
		DrawString(motto2);

		CenterString(motto3);	Move(0,g12InchMode? 16 : 32);
		DrawString(motto3);

		TextMode(srcCopy);
		LSpriteDraw(&sTable[TeaSprite]);

		break;
	}
	RGBForeColor(&sc);
	SetGWorld(curPort,curDevice);
	FlickerStars();
	MyCopyBits();
}

void AttractLoop(WindowPtr theWin)
{
	register long t;
	SpriteInstance *sp;
	t = TickCount();
	if (t - gLastDispTime >= gGameClockTicks) {
		//  Update the game clock
		++gGameClock;
		gLastDispTime = t;
		FlickerStars();
		UpdateStars();
		if (gGameClock > attractDisplayTicks[gAttractMode]) {
			gGameClock = 0;
			gAttractMode++;
			gAttractMode %= AT_NbrAttractModes;
			DisplayAttractMode();
		}
		switch (gAttractMode) {
		case AT_Beastiary:
			{
				short	i;
				Rect	r;
				for (i = 0,sp = sTable; i < NbrDemoSprites-1; ++i,++sp)
				{
					(*sDef[sp->type].eraseFunc)(sp);
					StandardSpriteMove(sp);
					(*sDef[sp->type].drawFunc)(sp);
					SetRect(&r,sp->pos.h,sp->pos.v,sp->pos.h+sp->width,sp->pos.v+sp->width);
					MyCopyRect(&r);
				}
			}
			break;
		case AT_Motto:
			{
				Rect	r;
				SpriteInstance *sp = &sTable[TeaSprite];
				LargeSpriteErase(sp);
				StandardSpriteMove(sp);
				LSpriteDraw(sp);
				SetRect(&r,sp->pos.h,sp->pos.v,sp->pos.h+sp->width,sp->pos.v+sp->width);
				MyCopyRect(&r);
			}
			break;
		}
	}
}

// Display Attract Mode Screen
void BeginAttract(void)
{
	short	i;
	register SpriteInstance *sp;

	gMaxSprite = 0;
	gSpriteCnt = 0;
	gSparkCnt = 0;
	gAsteroidCnt = 0;

	gOffsetPt.h = gOffsetPt.v = 0;
	gOldOffset = gOffsetPt;
	InitStars();

	descTop = gCenterP.v - (DescLeading*(NbrDemoSprites-1))/2;
	for (i = 0; i < NbrDemoSprites; ++i) {
		sp = NewSprite();
		sp->type = demoSprites[i];
		// sp->param1 = 0;
		sp->aniState = 0;
		sp->width = sDef[sp->type].class == SP_Large? 48 : 32;
		sp->pos.h = gCenterP.h + (sp->width == 48? -60 : -52);
		sp->pos.v = descTop + DescLeading * i;
		sp->vector.lh = sp->vector.lv = 0;
		sp->aniSpeed = 2;
	}
	sTable[TeaSprite].pos.h = gCenterP.h-24;
	sTable[TeaSprite].pos.v = 340;

	GammaFadeOut();
	gAttractMode = 0;
	gGameClock = 0;
	DisplayAttractMode();
	GammaFadeIn();
}

