// CToastVars.h

// Note: I'm using fixed point arithmetic here - the upper word is used for
// screen coords, this table was computed using Excel: Sin() * 65535

void StandardSpriteErase(register SpriteInstance *);
void StandardSpriteMove(register SpriteInstance *);
void StandardSpriteDraw(register SpriteInstance *);

void LargeSpriteErase(register SpriteInstance *);
void LSpriteDraw(register SpriteInstance *);

void MedSpriteErase(register SpriteInstance *);

void BulletErase(register SpriteInstance *);
void BulletMove(register SpriteInstance *);
void BulletDraw(register SpriteInstance *);
void CreamBulletErase(register SpriteInstance *);
void CreamBulletMove(register SpriteInstance *);
void PhotonDraw(register SpriteInstance *);
void SaucerMove(register SpriteInstance *);
void CoffeePotMove(register SpriteInstance *);
void ToasterMove(register SpriteInstance *);
void NookMove(register SpriteInstance *);
void CrannyMove(register SpriteInstance *);
void EMuffinMove(register SpriteInstance *);
void CroissantMove(register SpriteInstance *);
void CubeMove(register SpriteInstance *);
void YummyMove(register SpriteInstance *sp);
void CreamerMove(register SpriteInstance *sp);
void ShipMove(register SpriteInstance *);
void SparkErase(register SpriteInstance *);
void SparkMove(register SpriteInstance *);
void SparkDraw(register SpriteInstance *);
void NewShipTimer(register SpriteInstance *);
void NullFunc(register SpriteInstance *);
void QuakeMove(register SpriteInstance *);
void BeaterMove(register SpriteInstance *);
void MixerMove(register SpriteInstance *);
void ExplosionMove(register SpriteInstance *);

LongPoint	vecTable[MaxAngles] = {
				0L,			-65535L,
				12785L,		-64276L,
				25079L,		-60546L,
				36409L,		-54490L,
				46340L,		-46340L,
				54490L,		-36409L,
				60546L,		-25079L,
				64276L,		-12785L,
				65535L,		0L,
				64276L,		12785L,
				60546L,		25079L,
				54490L,		36409L,
				46340L,		46340L,
				36409L,		54490L,
				25079L,		60546L,
				12785L,		64276L,
				0L,			65535L,
				-12785L,	64276L,
				-25079L,	60546L,
				-36409L,	54490L,
				-46340L,	46340L,
				-54490L,	36409L,
				-60546L,	25079L,
				-64276L,	12785L,
				-65535L,	0L,
				-64276L,	-12785L,
				-60546L,	-25079L,
				-54490L,	-36409L,
				-46340L,	-46340L,
				-36409L,	-54490L,
				-25079L,	-60546L,
				-12785L,	-64276L};

#if DEBUGGING
Boolean			gDebug;
#endif

GWorldPtr		gOffScreen;		// Offscreen Drawing Area
short			gAssetFile;		// "CT Resources" file - contains sprites & snds
PixMapHandle	gPixMap;		// Offscreen Pixel Map
Boolean			g12InchMode;	// True if 512 x 384 mode, otherwise 640 x 480
Boolean			gClientMode;	// True if Client
short			gConnectionType; // Connection Type (AppleTalk, Serial, etc.)
short			gMaxSprite,		// Maximum sprites onscreen
				gSpriteCnt,		// Number of sprites onscreen
				gSparkCnt,		// Number of sparks onscreen
				gAsteroidCnt,	// Number of asteroids onscreen
				gMinAsteroids,	// Minimum number of asteroids
				gRemainingShips;	// Number of remaining free ships
short			gAttractMode;
// short			gNbrSaveMaps;	// Number of 32 x 32 savemaps in use
short			gYummyCnt,		// Number of "Yummies" onscreen
				gToasterCount,	// Number of toasters
				gMixerCount;	// Number of mixers
long			gScreenRowBytes,	// RowBytes for offscreen area
				gVideoRowBytes;	// RowBytes for onscreen video
Ptr				gScreenMem,		// BaseAddr for offscreen area
				gVideoMem;		// BaseAddr for onscreen video
Rect			gPlayRect,		// Bounds of legal sprite coordinates on offscreen
				gOffscreenRect,	// Bounds of offscreen drawing area
				gUnivRect;		// Bounds of universe
Point			gCenterP,		// Center of offscreen drawing area
				gVidOffset,		// Top,Left of onscreen Play field 
								// in global coordinates
				gOffsetPt,		// Scroll Point within Universe
				gOldOffset;		// Old gOffsetPt
long			gPlayWidth,		// Width of playing field
				gPlayHeight;	// Height of playing field
short			gVisPlayWidth,	// Width of visible part of play field
				gVisPlayHeight,	// height "
				gUnivWidth,		// Univ Height
				gUnivHeight,	// Univ Width
				gGraceTop,
				gGraceLeft,
				gGraceRight,
				gGraceBottom;
long			gGameClockTicks = 2L;		
								// 30 Frames per Second (was 20)
long			gGameClock;		// Incremented every 3 ticks
long			gLastDispTime = 0L;
								// Ticks of last frame
short			gGameState,		// Attract=0,Play=1,GameOver=2
				gGameLevel,		// Game Level - effects difficulty
				gLastLevel,		// Last Level - used to update display
				gLastRemainingShips;  // Last Remaining Ships - used to update display
short			gShipMode,		// Ship Modes - Magic Shield, Special Bullets
				gShieldPower,	// Power remaining in shields
				gLastShieldPower, // Used to update display
				gKeyFlags;		// Current Keyboard State
long			gScoreMultiply,	// Score Multiplier (times two, times three etc)
				gLastScoreMultiply;	// Used to update display
long			gGameScore,		// Current Score
				gLastScore,		// Last Score - used to trigger level increases
				gLastDrawnScore;// Last Score - used to update display
short			gBadGuyChance,	// Chance of bad guy appearing
				gYummyChance,	// Chance of Yummy appearing
				gToasterChance;	// Chance of Toaster Appearing
short			oldMBarHeight;	// Old Menu Bar Height

SpriteInstance	*sTable,		// Sprite Table
				*gShip;			// Pointer to Ship Sprite in sprite table, 
								// for quick access

unsigned long	spriteIDCtr;	// ID Counter for Sprites

StarInstance	*starTable;		// Table of Stars

// SaveMapRecord	*smTable;		// Save Map Table

WindowPtr		gWindow;

// Sprite Definition Table - defines behavior for each variety of sprite
// function pointers are used for drawing, erasing and moving
//


SpriteDef sDef[NbrSprites] = {
//  type      			iconID nbrIcons  MoveFunction       EraseFunction        DrawFunction
//  ----      			-----  -------   ------------      ---------------     --------------
	{ST_Wheel, 	SP_Med,	138, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_Aster,  SP_Med,	139, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_Teacup, SP_Large,	128, 12,	StandardSpriteMove,	LargeSpriteErase,	LSpriteDraw},
	{ST_Jim, 	SP_Med,	143,12,			StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_WheelR, SP_Med,	133, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_WheelG, SP_Med,	134, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_WheelB, SP_Med,	135, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_Aster1, SP_Med,	136, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_Aster2, SP_Med,	137, 12,		StandardSpriteMove, MedSpriteErase, 	LSpriteDraw},
	{ST_Saucer, SP_Med,	132, 18,		SaucerMove,			MedSpriteErase, 	LSpriteDraw},
	{ST_Croissant,SP_Large,	141,14,		CroissantMove,		LargeSpriteErase, 	LSpriteDraw},
	{ST_Cube,	SP_Med,	142, 18,		CubeMove,			 MedSpriteErase,	 LSpriteDraw},
	{ST_Teapot, SP_Large,	129,16,		ShipMove, 			LargeSpriteErase, 	LSpriteDraw},
	{ST_TeapotT,SP_Large,	130,16,		ShipMove, 			LargeSpriteErase, 	LSpriteDraw},
	{ST_TeapotS,SP_Large,	131,16,		ShipMove, 			LargeSpriteErase, 	LSpriteDraw},
	{ST_TeapotNew, SP_Custom,	0, 0,	NewShipTimer,		NullFunc, 			NullFunc},
	{ST_Yummies,SP_Med,	140, NbrYummies, YummyMove,			MedSpriteErase, 	LSpriteDraw},
	{ST_Bullet,	SP_Custom,	0,	  0,	BulletMove,			BulletErase,		BulletDraw},
	{ST_Photon,	SP_Custom,	0,	  0,	BulletMove,			BulletErase,		PhotonDraw},
	{ST_Spark,	SP_Custom,	0,	  0,	SparkMove,			SparkErase,			SparkDraw},
	{ST_Toaster, SP_Large,144,15,		ToasterMove,		LargeSpriteErase,	LSpriteDraw},
	{ST_SmallCup, SP_Med, 145,12,		StandardSpriteMove,	MedSpriteErase,		LSpriteDraw},
	{ST_Nook,	SP_Med,146,15,			NookMove,			MedSpriteErase,		LSpriteDraw},
	{ST_Cranny,	SP_Med,147,15,			CrannyMove,			MedSpriteErase,		LSpriteDraw},
	{ST_BigJim,	SP_Large,148,15,		StandardSpriteMove,	LargeSpriteErase,	LSpriteDraw},
	{ST_EMuffin,SP_Med, 149,8,			EMuffinMove,		MedSpriteErase,		LSpriteDraw},
	{ST_CoffeePot, SP_Large, 150, 15,	CoffeePotMove,		LargeSpriteErase,	LSpriteDraw},
	{ST_CreamBullet, SP_Med, 151, 3,	CreamBulletMove,	CreamBulletErase,	LSpriteDraw},
	{ST_Creamer, SP_Large, 152, 23, 	CreamerMove,		LargeSpriteErase,	LSpriteDraw},
	{ST_Beater, SP_Med, 154,	24,		BeaterMove,			MedSpriteErase,		LSpriteDraw},
	{ST_Mixer, SP_Large, 155,	85,		MixerMove,			LargeSpriteErase,	LSpriteDraw},
	{ST_Quake, SP_Custom, 0, 0,			QuakeMove,			NullFunc,			NullFunc},
	{ST_Explosion, SP_Large, 156,	9,	ExplosionMove,		LargeSpriteErase,	LSpriteDraw},
	};



unsigned char gRadarColor[NbrSprites] = {AsterColor,AsterColor,AsterColor,AsterColor,
							  			 AsterColor,AsterColor,AsterColor,AsterColor,
							  			 AsterColor,BadColor,BadColor,BadColor,
							   			TeaColor,TeaColor,TeaColor,Invisible,	// tea tea tea tea
							   			YummyColor,Invisible,Invisible,Invisible,
							   			BadColor,AsterColor,BadColor,BadColor,
							   			AsterColor,BadColor,BadColor,Invisible,
							   			YummyColor, BadColor, BadColor, Invisible,
							   			Invisible,
							   			};


unsigned char gBulletFlag[NbrSprites] = {0x03,	0x03,	0x03,	0x03,
										 0x03,	0x03,	0x03,	0x03,
										 0x03,	0x03,	0x03,	0x03,
										 0x04,	0x04,	0x04,	0x04,
										 0x03,	0x00,	0x00,	0x00,
										 0x03,	0x03,	0x03,	0x03,
										 0x03,	0x03,	0x03,	0x00,
										 0x03,	0x03,	0x03,	0x00,
										 0x00,
										 };
										