/************************************************************************************
 * GameSounds.c
 *
 * CheeseToast by Jim Bumgardner
 *
 * 2/28/95
 *		Updated to compile using newer Think C / Metrowerks compiler
 *
 ************************************************************************************/

#include "CToast.h"
#include <Sound.h>

static Handle			sounds[S_NbrSounds];
static SndChannelPtr	scp;
static SndCommand		tCmd;						/* Sound Command */
static short			savedVolume;
SndCallBackUPP			mySndCallBack;

pascal void MyCallBack(SndChannelPtr chan, SndCommand *cmd)
{
	chan->userInfo = 0;
}

void InitSounds()
{
	short	i;
	OSErr	oe;
	for (i = 0; i < S_NbrSounds; ++i) {
		sounds[i] = GetAsset('snd ',128+i);
		if (sounds[i] != NULL) {
			HNoPurge(sounds[i]);
			MoveHHi(sounds[i]);
			HLock(sounds[i]);
		}
	}
	mySndCallBack = NewSndCallBackProc((ProcPtr) MyCallBack);
	scp = (SndChannelPtr) NewPtrClear((long) sizeof(SndChannel));
	scp->qLength = stdQLength;
	if ((oe = SndNewChannel(&scp,sampledSynth,initMono,mySndCallBack)) != noErr)
		DebugStr("\pSound Problem");

	GetSoundVol(&savedVolume);
	SetSoundVol(gPrefs.soundLevel);
}

void EndSounds()
{
	if (scp) {
		SndDisposeChannel(scp,true);
		DisposPtr((Ptr) scp);
		scp = 0L;
	}
	SetSoundVol(savedVolume);
}

void InitGameSound()
{
	DisposeHandle(sounds[S_Startup]);
	sounds[S_Startup] = NULL;
}

void PlaySound(short i, short priority)
{
	if (gPrefs.soundLevel > 0 && i < S_NbrSounds && sounds[i] &&
		priority > scp->userInfo) {
		tCmd.cmd = quietCmd;
		SndDoImmediate(scp,&tCmd);
		tCmd.cmd = flushCmd;
		SndDoImmediate(scp,&tCmd);
#ifdef THINK_C
		SndPlay(scp, sounds[i], true);
#else
		SndPlay(scp, (SndListHandle) sounds[i], true);
#endif
		scp->userInfo = priority;
		tCmd.cmd = callBackCmd;
		SndDoCommand(scp,&tCmd,true);
	}
}
