// Stars.c

#include "CToast.h"

short	gMaxStar;

#define MaxStars		64

void InitStars()
{
	short	n;

	// Move to InitGame later...
	if (starTable == NULL) {
		starTable = (StarInstance *) NewPtrClear(sizeof(StarInstance) * MaxStars);
		if (starTable == NULL)
			DebugStr("\pOut of Mem");
	}

	gMaxStar = 0;
	for (n = 0; n < MaxStars; ++n) {
		NewStar();
	}
}

void NewStar(void)
{
	register StarInstance *sp;

	sp = &starTable[gMaxStar++];

	sp->baseShade = 245+MyRandom(9);
	sp->flickerCounter = MyRandom(22);
	sp->pos.h = MyRandom(gVisPlayWidth);
	sp->pos.v = MyRandom(gVisPlayHeight);
	sp->saveColor = 255;
}

void EraseStars()
{
	short			i;
	StarInstance	*sp;
	register Ptr	scrnPtr;
	register Point	loc;

	i = gMaxStar;
	sp = &starTable[i-1];

	for (; i--; --sp) {
		loc = sp->pos;
		loc.h += gUnivWidth - gOldOffset.h;			loc.h %= gVisPlayWidth;
		loc.v += gUnivHeight - gOldOffset.v;		loc.v %= gVisPlayHeight;
		loc.h += SafeWidth;
		loc.v += SafeHeight;
		if (loc.v <= SafeHeight + StatusHeight)
			continue;
		// if (!PtInRect(loc,&gPlayRect))
		//	continue;
		scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
		*scrnPtr = sp->saveColor;	// Restore original screen color
	}
}

void FlickerStars()
{
	short			n,i;
	StarInstance	*sp;
	register Ptr	scrnPtr;
	register char	color;
	register Point	loc;

	static char	brightTable[22]= {1,0,0,1,1,1,1,1,0,1,1,0,1,1,1,1,1,0,0,1,1,1};

	n = gMaxStar;
	for (i = 0,sp=starTable; i < n; ++i,++sp) {
		// Update Star Position
		sp->flickerCounter++;
		if (sp->flickerCounter >= 22)
			sp->flickerCounter= 0;
		color = sp->baseShade + brightTable[sp->flickerCounter];	// Flicker
		loc = sp->pos;
		loc.h += gUnivWidth - gOffsetPt.h;			loc.h %= gVisPlayWidth;
		loc.v += gUnivHeight - gOffsetPt.v;		loc.v %= gVisPlayHeight;
		loc.h += SafeWidth;
		loc.v += SafeHeight;
		if (loc.v <= SafeHeight + StatusHeight)
			continue;
		scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
		sp->saveColor = *scrnPtr;	// Save original color, so spark can be erased
		*scrnPtr = color;				// Draw spark
	}
}

void UpdateStars()	// Copy Star Pixels Onscreen
{
	short			n,i;
	StarInstance	*sp;
	register Ptr	scrnPtr,vidPtr,vidBase;
	register Point	loc;
	SInt8			mmode;
	mmode = true32b;
	SwapMMUMode(&mmode);

	n = gMaxStar;
	vidBase = gVideoMem + (gVidOffset.v * gVideoRowBytes) + gVidOffset.h;
	if (!EqualPt(gOffsetPt,gOldOffset)) {
		for (i = 0,sp=starTable; i < n; ++i,++sp) {
			// Update Star Position
			loc = sp->pos;
			loc.h += gUnivWidth - gOldOffset.h;		loc.h %= gVisPlayWidth;
			loc.v += gUnivHeight - gOldOffset.v;		loc.v %= gVisPlayHeight;
			loc.h += SafeWidth;
			loc.v += SafeHeight;
			if (loc.v <= SafeHeight+StatusHeight)
				continue;
			scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
			vidPtr = vidBase + (loc.h-SafeWidth) + ((loc.v-SafeHeight)*gVideoRowBytes);
			*vidPtr = *scrnPtr;
		}
	}
	for (i = 0,sp=starTable; i < n; ++i,++sp) {
		// Update Star Position
		loc = sp->pos;
		loc.h += gUnivWidth - gOffsetPt.h;			loc.h %= gVisPlayWidth;
		loc.v += gUnivHeight - gOffsetPt.v;		loc.v %= gVisPlayHeight;
		loc.h += SafeWidth;
		loc.v += SafeHeight;
		if (loc.v <= SafeHeight + StatusHeight)
			continue;
		scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
		vidPtr = vidBase + (loc.h-SafeWidth) + ((loc.v-SafeHeight)*gVideoRowBytes);
		*vidPtr = *scrnPtr;
	}
	SwapMMUMode(&mmode);
}


void SprinkleStars()	// Copy Star Pixels Onscreen
{
	short			n,i;
	register unsigned char	*vidPtr;
	register Ptr	vidBase;
	register Point	loc;
	SInt8			mmode;
	unsigned char	color;

	mmode = true32b;
	SwapMMUMode(&mmode);

	n = gMaxStar;
	vidBase = gVideoMem+ (gVidOffset.v * gVideoRowBytes) + gVidOffset.h;
	for (i = 0; i < 640; ++i) {
		// Update Star Position
		loc.h = MyRandom(gVisPlayWidth);
		loc.v = MyRandom(gVisPlayHeight);
		vidPtr = (unsigned char *) vidBase + loc.h + (loc.v*gVideoRowBytes);
		color = 245+MyRandom(9);
		if (*vidPtr == 255)
			*vidPtr = color;
	}
	SwapMMUMode(&mmode);
}
